
#import <objc/Object.h>
#import <sys/param.h>
#import <appkit/graphics.h>
#import "MPEGView.h"

#define I_WIDTH		0
#define I_HEIGHT	1
#define I_ASPECT	2
#define I_PICT_RATE	3
#define I_BIT_RATE	4

#define STATS_TOTAL		0
#define STATS_FRAMES	1
#define STATS_FPS_RATE	2
#define STATS_ELAPSED	3
#define STATS_ORIG_TIME	4

#define FLAG_SYNC	0
#define FLAG_DROP	1

@interface Controller:Object
{
	id panel;
	id form;
	id colorSpaceMatrix;
	id zoomMatrix;
	id backingMatrix;
	id buttonMatrix;
	id statsForm;
	id attributesForm;
	id fpsForm;
	id fpsSlider;
	id playAgainMenuItem;
	BOOL drop, sync;
	int backing;
	int zoom;
	int colorSpace;
}

/*** Instance methods ***/
- (mpegInfo *)getMPEGFrameSize:(NXSize *)fSize forFile:(const char *)mpegFile;
- showInfo:(mpegInfo *)pInfo;
- setFrameNumber:(int)frame;
- (int)frameNumber;

/*** Instance variable access methods ***/
- setColorSpace:sender;
- (int)colorSpace;
- setZoom:sender;
- (int)zoom;
- setBacking:sender;
- setFlag:sender;
- setFPS:sender;

/*** Target/Action methods ***/
- openRequest:sender;
- playAgain:sender;
- updateInfoPanels:sender;
- setFPS:sender;

/*** Application delegate methods ***/
- appWillInit:sender;
- (BOOL)appAcceptsAnotherFile:sender;
- (int)app:sender openFile:(const char *)filename type:(const char *)aType;

/*** Window delegate methods ***/
- windowDidMove:sender;
- windowWillClose:sender;
- windowDidBecomeMain:sender;

@end
